
package lexcup;

import java_cup.runtime.*;
import java.io.IOException;

%%

%class lexer

%unicode
%line
%column

%public
//%final

%cup


%init{
	// TODO: code that goes to constructor
%init}

%{
	private Symbol sym(int type)
	{
		return sym(type, yytext());
	}

	private Symbol sym(int type, Object value)
	{
		return new Symbol(type, yyline, yycolumn, value);
	}

	private void error()
	throws IOException
	{
		throw new IOException("illegal text at line = "+yyline+", column = "+yycolumn+", text = '"+yytext()+"'");
	}
	
	private void syntaxError(){
		System.out.println("illegal text at line = "+yyline+", column = "+yycolumn+", text = '"+yytext()+"'");
	}
	
%}

ANY = .|\n     

LineTerminator = \r|\n|\r\n
WhiteSpace = [ \t\f]

Note = [a-g]
Event = "ev"

%%

{Note}				{	return new Symbol( sym.NOTE, new Character( yytext().charAt(0) ) ); }
{Event}				{  	
						return new Symbol (sym.EVENT) ; 
					}

{LineTerminator}|{WhiteSpace}  		{  /* ignore */ }

{ANY}				{	
						syntaxError();
						//return new Symbol ( sym.ILLEGAL ); 
					}

