
package lexcup;

import java_cup.runtime.*;
import java.io.IOException;

%%

%class lexer

%unicode
%line
%column

%public
//%final

%cup


%init{
	// TODO: code that goes to constructor
%init}

%{
	private Symbol sym(int type)
	{
		return sym(type, yytext());
	}

	private Symbol sym(int type, Object value)
	{
		return new Symbol(type, yyline, yycolumn, value);
	}

	private void error()
	throws IOException
	{
		throw new IOException("illegal text at line = "+yyline+", column = "+yycolumn+", text = '"+yytext()+"'");
	}
	
	private void syntaxError(){
		System.out.println("illegal text at line = "+yyline+", column = "+yycolumn+", text = '"+yytext()+"'");
	}
	
%}

    

LineTerminator = \r|\n|\r\n
WhiteSpace = [ \t\f]

Note = [a-g][#b]?(1|2|4|8|16|32|64|128)
InvalidNote = [a-g][#b]?[:digit:]+
Octave = OCT[0-9]

Event = "ev"

ANY = .|\n 

%%

{Note}				{	return new Symbol( sym.NOTE, new String( yytext() ) ); }
{Octave}			{
						return new Symbol( sym.OCTAVE_SELECT, new Integer( yytext().substring(3) ) );
					}
{Event}				{  	
						return new Symbol (sym.EVENT) ; 
					}

{LineTerminator}|{WhiteSpace}  		{  /* ignore */ }

{InvalidNote}		{	
						//TODO report syntax error
						System.out.println("invalid note! "+yytext()); 
					}
{ANY}				{	
						syntaxError();
						//return new Symbol ( sym.ILLEGAL ); 
					}

